// Generated by CoffeeScript 1.7.1
var Form, JFUM, createWriteStream, hash, rand;

Form = require('multiparty').Form;

createWriteStream = require('fs').createWriteStream;

hash = require('crypto').createHash;

rand = require('crypto').pseudoRandomBytes;

JFUM = module.exports = function(opts) {
  if (opts == null) {
    opts = {};
  }
  this.tmpDir = opts.tmpDir || require('os').tmpdir();
  this.minFileSize = opts.minFileSize || 204800;
  this.maxFileSize = opts.maxFileSize || 5242880;
  this.acceptFileTypes = opts.acceptFileTypes || /\.(gif|jpe?g|png)$/i;
  return this;
};

JFUM.prototype.optionsHandler = function(req, res, next) {
  res.set({
    'Access-Control-Allow-Methods': 'OPTIONS, POST',
    'Access-Control-Allow-Headers': 'Content-Type'
  });
  return next();
};

JFUM.prototype.postHandler = function(req, res, next) {
  var form;
  req.jfum = {
    files: []
  };
  form = new Form();
  form.on('error', next);
  form.on('close', next);
  form.on('part', (function(_this) {
    return function(part) {
      var i;
      if (!part.filename || !_this.acceptFileTypes.test(part.filename)) {
        req.jfum.files.push({
          error: {
            code: 'JFUM-001',
            msg: 'File type not allowed'
          }
        });
        return part.pipe(createWriteStream('/dev/null').on('error', next));
      }
      if (_this.maxFileSize < part.byteCount) {
        req.jfum.files.push({
          error: {
            code: 'JFUM-002',
            msg: 'File size too big'
          }
        });
        return part.pipe(createWriteStream('/dev/null').on('error', next));
      }
      if (_this.minFileSize > part.byteCount) {
        req.jfum.files.push({
          error: {
            code: 'JFUM-003',
            msg: 'File size too small'
          }
        });
        return part.pipe(createWriteStream('/dev/null').on('error', next));
      }
      i = req.jfum.files.push({
        path: _this.tmpDir + '/jfum-' + hash('sha1').update(rand(128)).digest('hex'),
        name: part.filename,
        size: part.byteCount,
        mime: part.headers['content-type']
      });
      return part.pipe(createWriteStream(req.jfum.files[i - 1].path).on('error', next));
    };
  })(this));
  return form.parse(req);
};
